battleCharacterModule = {
	mt = {},

	New = function()
		local self = {}
		setmetatable( self, battleCharacterModule.mt) --binds metaTable to table
		for k,v in pairs(battleCharacterModule) do --loops through table (even with named indexes)
			self[k] = v -- matches a key in the vec table to a value
			--vec.k = v is the same thing
		end
		self.name = "unnamed"
		self.health = 100
		self.weakAgainst = {}
		self.stringAgainst = {}
		self.icon = ""
		self.gameObjectUrl = nil
		return self
	end,

	isDead = function(self)
		if self.health <= 0 then
			return true
		else
			return false
		end
	end,

	getName = function(self)
		return self.name
	end,

	animateGO = function(self)
		error("Override in character")
	end,

	setGO = function(self, GO)
		self.gameObjectUrl = GO
		local message = {}
		message.icon = self.icon
		msg.post(self.gameObjectUrl, hash("set_character_icon"), message)
		self:animateGO()
	end,

	getGO = function(self)
		return self.gameObjectUrl
	end
}