require("main.battleSystem.battleCharacterModule")

ghostEnemyModule = battleCharacterModule.New()

function ghostEnemyModule.New()
	local self = {}
	setmetatable( self, ghostEnemyModule.mt) --binds metaTable to table
	for k,v in pairs(ghostEnemyModule) do --loops through table (even with named indexes)
		self[k] = v -- matches a key in the vec table to a value
		--vec.k = v is the same thing
	end
	self.name = "Ghost"
	self.health = 25
	self.weakAgainst = {}
	self.stringAgainst = {}
	self.icon = "enemy_ghost"
	self.gameObjectUrl = nil
	return self
end

function ghostEnemyModule.animateGO(self)
	local position = go.get_position(self.gameObjectUrl)
	position.y = position.y + 25
	local time = 4
	go.animate(self.gameObjectUrl, "position", go.PLAYBACK_LOOP_PINGPONG, position, go.EASING_INOUTSINE, time)
end