profile = {
	mt = {},

	New = function()
		local self = {}
		setmetatable( self, profile.mt) --binds metaTable to table
		for k,v in pairs(profile) do --loops through table (even with named indexes)
			self[k] = v -- matches a key in the vec table to a value
			--vec.k = v is the same thing
		end
		self.worlds = {}
		return self
	end,

	load = function(self, worlds)
		self.worlds = worlds
	end,

	--------------
	--World Data--
	--------------

	worldNameIsInList = function(self, worldName)
		if worldName == nil then
			error("World name must be provided to check")
		end

		--Make sure it can exist
		if self.worlds == nil then
			return false
		elseif #self.worlds == 0 then
			return false
		end

		--Check for world
		for key, value in pairs(self.worlds) do
			if value.worldName == worldName then
				return true, value
			end
		end
		return false
	end,

	saveWorld = function(self, worldName, currentLevel)
		--Clear table between worlds?
		if worldName == nil then
			error("World name must be provided")
		end
		if currentLevel == nil then
			error("Current Level must be provided")
		end

		local worldExists, world = self:worldNameIsInList(worldName)
		if worldExists then
			-- World does exist
			for key, value in pairs(self.worlds) do
				if value.worldName == worldName then
					local newSave = currentLevel:save()
					value.shops = newSave.shops
					value.worldSafeInfo = newSave.worldSafeInfo
					break
				end
			end
		else
			-- World does not exist
			local world = currentLevel:save()
			if self.worlds == nil then
				self.worlds = {}
			end
			table.insert(self.worlds, world)
		end
	end,

	loadWorld = function(self, worldName, currentLevel)
		if worldName == nil then
			error("World name must be provided to load")
		end
		if currentLevel == nil then
			error("Current Level must be provided")
		end

		local worldExists, world = self:worldNameIsInList(worldName)

		if worldExists then
			return world
		else
			print("World does not yet exist.")
			return nil
		end
	end
}



