local function findSubString(self, message, subString)
	i,j = string.find(message, subString)
	if i == nil then
		return false
	else
		local returnMSG = {}
		returnMSG.start = i
		returnMSG.finish = j
		return returnMSG
	end
end

function getDisplayableText(self, message, limit)
	local returnMSG = {}
	returnMSG.toDisplay = ""
	returnMSG.remaining = ""
	local hasBreak = findSubString(self, message, "/break/")

	if string.len(message) < limit or ( hasBreak ~= false and hasBreak.start <= limit ) then
		if hasBreak == false then
			returnMSG.toDisplay = message
			return returnMSG
		else
			local startPosition = hasBreak.start
			local endPosition = hasBreak.finish
			returnMSG.toDisplay = string.sub(message, 1, startPosition - 1) .. "..."
			returnMSG.remaining = "..." .. string.sub(message, endPosition + 1)
			return returnMSG
		end
	else
		local currDisplay = ""
		local leftOver = ""
		local lastcharGotten = 0
		local done = false

		while not done do
			local space = findSubString(self, string.sub(message, lastcharGotten), " ")
			if space == false then
				if lastcharGotten == 0 then
					--no more spaces, all remaining to the final message
					currDisplay = string.sub(message, 1, limit)
					leftOver = string.sub(message, limit+1)
					done = true
				else
					currDisplay = string.sub(message, 1, lastcharGotten -1)
					leftOver = string.sub(message, lastcharGotten)
					done = true
				end

			elseif lastcharGotten + space.finish >= limit then
				currDisplay = string.sub(message, 1, lastcharGotten-1)
				leftOver = string.sub(message, lastcharGotten)
				done = true

			else
				--space has been found, within range
				lastcharGotten = lastcharGotten + space.finish
			end
		end
		returnMSG.toDisplay = currDisplay .. "..."
		returnMSG.remaining = "..." .. leftOver
		return returnMSG
	end
end

