leafListNode = {
	mt = {},

	new = function(myParent, myId)
		local lf = {}
		setmetatable( lf, leafListNode.mt) --binds metaTable to table
		for k,v in pairs(leafListNode) do --loops through table (even with named indexes)
			lf[k] = v -- matches a key in the vec table to a value
			--vec.k = v is the same thing
		end
		lf.parent = myParent
		lf.id = myId
		lf.list = {}
		lf.children = {}
		return  lf
	end,

	--add functions
	addItem = function(self, newItem)
		table.insert(self.list, newItem)
	end,

	addItemList = function(self, newListItem)
		local numCurrentItems = #self.list + 1
		for i=1, #newListItem do
			self.list[numCurrentItems] = newListItem[i]
			numCurrentItems = numCurrentItems + 1
		end
	end,

	addChild = function(self, newChild)
		table.insert(self.children, newChild)
	end,

	addChildren = function(self, children)
		local numCurrentChildren = #self.children + 1
		for i=1, #children do
			self.children[numCurrentChildren] = children[i]
			numCurrentChildren = numCurrentChildren + 1
		end
	end,

	--set functions

	setParent = function(self, newParent)
		self.parent = newParent
	end,

	--chech functions

	hasParent = function(self)
		if (self.parrent == nil) then
			return false
		else
			return true
		end
	end,

	--get functions

	getItemList = function(self)
		return self.list
	end,

	getItemByPos = function(self, pos)
		return self.list[pos]
	end,

	getChildren = function(self)
		return self.children
	end,

	getChildByPos = function(self, pos)
		return self.children[pos]
	end,

	getChildById = function(self, id)
		if self.children == nil then
			error("Children has not been initialized")
		end
		for i = 1, #self.children do
			if self.children[i] == id then
				return self.children[i]
			end
		end
	end,

	getParent = function(self)
		return self.parent
	end
}